LeetCode 面试题 01.08. 零矩阵

文章目录

一、题目

  编写一种算法,若M × N矩阵中某个元素为0,则将其所在的行与列清零。

  点击此处跳转题目。

示例 1:

输入:

\[1,1,1\], \[1,0,1\], \[1,1,1

]

输出:

\[1,0,1\], \[0,0,0\], \[1,0,1

]

示例 2:

输入:

\[0,1,2,0\], \[3,4,5,2\], \[1,3,1,5

]

输出:

\[0,0,0,0\], \[0,4,5,0\], \[0,3,1,0

]

二、C# 题解

  此题有很多方法解,无外乎都是记录需要清零的行与列,这种写法太无聊了。这里提出一种递归的方式,只需要遍历矩阵一次即可。当遇到 0 时,使用 set0 变量记录该位置,遍历完成后,重置所有 set0。

csharp 复制代码
public class Solution {
    public void SetZeroes(int[][] matrix) {
        BFS(ref matrix, 0, 0); // 广度优先遍历
    }

    public void BFS(ref int[][] matrix, int i, int j) {
        int m = matrix.Length, n = matrix[0].Length;

        if (i == m && j == 0) return; // 递归出口

        // 计算下一个位置
        int next_i = i, next_j = j + 1;
        if (next_j == n) {
            next_j = 0;
            next_i++;
        }

        bool set0 = matrix[i][j] == 0;   // 记录当前状态,是否需要清零

        BFS(ref matrix, next_i, next_j); // 继续遍历

        // 最后执行清零
        if (set0) {
            for (int p = 0; p < n; p++) matrix[i][p] = 0;
            for (int q = 0; q < m; q++) matrix[q][j] = 0;
        }
    }
}
  • 时间复杂度: O ( m × n ) O(m\times n) O(m×n)。
  • 空间复杂度:由矩阵中 0 出现的次数决定。

  该方法依据元素记录,因此当矩阵中 0 出现次数过多时,会有重复操作,只适合处理稀疏 0 矩阵。

  矩阵中 0 过于密集时,使用记录行列的方式会更好些,但可能需要更多的空间和遍历次数。

相关推荐
一去不复返的通信er6 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
程序 代码狂人9 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade10 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
Xin77011 小时前
LeetCode 79. 单词搜索(DFS 回溯法)
leetcode
小郎君65812 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一13 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS10013 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao13 小时前
算法56,重排链表
数据结构·算法·链表
qq_4523962314 小时前
第四篇:《索引原理与实战:B-tree、Hash、GIN、GiST、BRIN》
算法·哈希算法·gin